
#include "ST7565_homephone.h"
// add a bitmap library of a 16x16 fruit icon
#include "bmps.h"
ST7565 lcd(3,4,5,6);

#ifdef __AVR__
#include <avr/io.h>
#include <avr/pgmspace.h> 
#endif
/** Nhân vật Cả Mẹo (22x18)pixel
*/
const static unsigned char __attribute__ ((progmem)) ca_meo_22x18[] = {
0x60, 0x9C, 0x62, 0x01, 0x01, 0xC1, 0x26, 0x29, 0x29, 0x4B, 0x4E, 0x48, 0x70, 0x00, 0xC0, 0x80,
0x80, 0x80, 0x80, 0x80, 0x80, 0xC0, 0x00, 0x00, 0x01, 0x01, 0x02, 0xE4, 0xFF, 0xFE, 0xFE, 0xFE,
0xFC, 0x1C, 0x0E, 0x06, 0x1F, 0x21, 0x52, 0x44, 0x48, 0x52, 0x21, 0x1F, 0x00, 0x00, 0x64, 0x70,
0x2F, 

};
/** Nhân vật Dần Béo (23x19)pixel
*/
const static unsigned char __attribute__ ((progmem)) dan_beo_23x19[] = {
0x00, 0x00, 0x80, 0x43, 0xB2, 0x0F, 0x86, 0x44, 0x5C, 0xA2, 0xA6, 0x5C, 0x50, 0xB0, 0x40, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x40, 0xE3, 0xF4, 0xFA, 0xF0, 0xF7, 0x28, 0x78,
0xD8, 0xA8, 0xA8, 0xA4, 0x90, 0x58, 0x3E, 0x0A, 0x11, 0x11, 0x11, 0x11, 0x0A, 0x04, 0x07, 0x07,
0x06, 0x06, 0x05, 0x07, 0x07, 0x04, 
};
/* mũi tên
 *  
 */
const static unsigned char __attribute__ ((progmem)) mui_ten_5x4[] = {

  0x01, 0x07,0x0F, 0x07,0x01,

};
// mảng cho 2 nhân vật Cả mẹo(0) và Dần béo(1)
byte object2[2][4]={0};
//object[i][0]: tồn tại hay không
//object[i][1]: tọa độ x
//object[i][2]: tọa độ y
//object[i][3]: hướng (1 phải, 2 trên , 3 trái, 4 dưới)
//
byte chon_nv_A;
byte chon_nv_B;
//lựa chọn nhân vật, mặc định A được chọn trước
byte Xmin, Ymin,Xmax, Ymax;//biên
//cài đặt chân input
#define fight_b A5
#define select_b A4
#define right_b A3
#define up_b A2
#define left_b A1
#define down_b A0
// Chương trình chạy 1 lần
void setup()   {                
Serial.begin(9600);
  lcd.ON(); 
  lcd.SET(23,0,0,0,4);
  
pinMode(left_b,INPUT_PULLUP);       
pinMode(down_b,INPUT_PULLUP);
pinMode(right_b,INPUT_PULLUP); 
pinMode(up_b,INPUT_PULLUP); 
pinMode(fight_b,INPUT_PULLUP); 
pinMode(select_b,INPUT_PULLUP);

  
Xmin=0;
Xmax=125;
Ymin=0;
Ymax=63;
chon_nv_A=1;
chon_nv_B=0;
}

////////ĐIỀU KHIỂN 2 NHÂN VẬT//////////////////////
void ve_nhan_vat(byte x, byte y,byte huong,byte i){
  switch (i){

case 0:
    // vẽ Cả Mẹo
    if(huong==1){
      //quay về bên phải
      lcd.Plus_Bitmap(x,y,22,18,ca_meo_22x18,  0,NO_MIRROR,BLACK);
    }
    if(huong==3){
      //quay về bên trái
      lcd.Plus_Bitmap(x,y,22,18,ca_meo_22x18,0,MIRROR,BLACK);
    }
    lcd.display();
break;
case 1:
  
    if(huong==1){
      //quay về bên phải
      lcd.Plus_Bitmap(x,y,23,19,dan_beo_23x19,0,NO_MIRROR,BLACK);
    }
    if(huong==3){
      //quay về bên trái
      lcd.Plus_Bitmap(x,y,23,19,dan_beo_23x19, 0,MIRROR,BLACK);
    }
  
    lcd.display();
    //vẽ Dần Béo
  break;
  default:
  break;
}//switch

}// ve nhân vật
void xoa_nhan_vat(byte x, byte y){
lcd.fillrect(x,y-7,24,19+7,DELETE);
lcd.display();
  
}// xóa nhân vật
void ve_mui_ten(byte x, byte y){
  // mũi tên sẽ chỉ vào nhân vật i
    lcd.bitmap(x,y,5,4,mui_ten_5x4, BLACK);
    lcd.display();
   
}// vẽ mũi tên
void xoa_mui_ten(byte i){
  lcd.fillrect(object2[i][1]-5,object2[i][2]-7,20,5 ,DELETE);
  lcd.display();
}//xóa mũi tên

void di_chuyen_nhan_vat(byte i){
byte x_cu, y_cu, huong_cu;
byte x_moi;
//lấy thông tin
x_cu=object2[i][1];
y_cu=object2[i][2];
huong_cu=object2[i][3];
if(huong_cu==1){
  //đi về bên phải
  x_moi=x_cu+4;
  ve_nhan_vat(x_moi, y_cu, huong_cu, i);
  ve_mui_ten(x_cu+5, y_cu-7);
  
}

if(huong_cu==3){
  //đi về bên trái
  
  if(x_cu>=Xmin+4*2){
    //chống quá biên
  x_moi=x_cu-4;
  } else{
    x_moi=x_cu;
  }
  ve_nhan_vat(x_moi, y_cu, huong_cu, i); 
  
  ve_mui_ten(x_cu+5, y_cu-7);
}
//lưu thông tin

 object2[i][1]=x_moi; 


}//di chuyển nhân vật
void xu_li_nhan_vat(){
//b0: điều khiển lựa chọn nhân vật
if(digitalRead(fight_b)==0){//fight được nhấn
   if ( chon_nv_A == chon_nv_B){// đề phòng A bằng B
  chon_nv_A=1;
    chon_nv_B=0;
   }
  if ( chon_nv_A!= chon_nv_B){//để dảm bảo A khác B
chon_nv_A=!chon_nv_A;
chon_nv_B=!chon_nv_B;
  //đổi 
  }
}//if
  //b1: chọn nhân vật
byte i=0;
if ( (chon_nv_A == 1)&&(chon_nv_B == 0)){
  i=0;// nhân vật Cả Mẹo

}
if ( (chon_nv_A == 0)&&(chon_nv_B == 1)){
  i=1;// nhân vật Dần Béo
}
if(digitalRead(fight_b)==0){//fight được nhấn
  
  xoa_mui_ten(!i);
  ve_mui_ten( object2[i][1]+5, object2[i][2]-7);
}

  //b2: cấp giấy khai sinh (chỉ dùng khi start game)
if(object2[i][0]==0){
  // nếu không tồn tại gà thì phải tạo gà
  // cấp thuộc tính cho đối tượng gà
  object2[i][1]=Xmin+50*i;//hoành độ ban đầu
  object2[i][2]= Ymax-19; // tung độ ban đầu
  object2[i][3]=1 ;//hướng về bên phải
  object2[i][0]=1; //cấp quyền tồn tại
}

 
//b4: vẽ 2 nhân vật

for (byte j=0; j<=1; j++){
  
ve_nhan_vat(object2[j][1],object2[j][2],object2[j][3],j);
}
//b5: điều khiển hướng nhân vật i
byte read_button;
read_button =lcd.Pullup_4(right_b, up_b, left_b, down_b);
if( read_button==1){// nút right
  //ghi lại tt hướng
   object2[i][3]=1;
   xoa_mui_ten(!i);
 

  xoa_nhan_vat(object2[i][1],object2[i][2]);//xóa ảnh cũ
  //lấy thông tin tọa độ để xóa
  
di_chuyen_nhan_vat(i);// vẽ ảnh mới

}

if( read_button==3){// nút left
   object2[i][3]=3;
   xoa_mui_ten(!i);
  xoa_nhan_vat(object2[i][1],object2[i][2]);//xóa ảnh cũ
  //lấy thông tin tọa độ để xóa
  
di_chuyen_nhan_vat(i);// vẽ ảnh mới

}

}//xử lí nhân vật
//==================================================
void loop() {
  xu_li_nhan_vat();
  delay(50);
}
