
#include "ST7565_homephone.h"
// add a bitmap library of a 16x16 fruit icon
#include "bmps.h"
ST7565 lcd(3,4,5,6);

#ifdef __AVR__
#include <avr/io.h>
#include <avr/pgmspace.h> 
#endif

const static unsigned char __attribute__ ((progmem)) ga_mai_16x16[]= {
0x20, 0xD8, 0x2C, 0x0C, 0x9E, 0x72, 0x42, 0xC0, 0x40, 0x40, 0x60, 0xFC, 0xCE, 0x3B, 0x7B, 0x01,
0x00, 0x06, 0x09, 0x10, 0x30, 0x48, 0x44, 0x4E, 0x59, 0x71, 0x39, 0x1F, 0x0E, 0x00, 0x00, 0x00
};
/* Qủa trứng (6x7) pixel
 *  */
 
const static unsigned char __attribute__ ((progmem)) trung_6x7 [] = {
0x1C, 0x22, 0x41, 0x41, 0x22, 0x1C, 
};
/** Nhân vật Cả Mẹo (22x18)pixel
*/
const static unsigned char __attribute__ ((progmem)) ca_meo_22x18[] = {
0x60, 0x9C, 0x62, 0x01, 0x01, 0xC1, 0x26, 0x29, 0x29, 0x4B, 0x4E, 0x48, 0x70, 0x00, 0xC0, 0x80,
0x80, 0x80, 0x80, 0x80, 0x80, 0xC0, 0x00, 0x00, 0x01, 0x01, 0x02, 0xE4, 0xFF, 0xFE, 0xFE, 0xFE,
0xFC, 0x1C, 0x0E, 0x06, 0x1F, 0x21, 0x52, 0x44, 0x48, 0x52, 0x21, 0x1F, 0x00, 0x00, 0x64, 0x70,
0x2F, 

};
/** Nhân vật Dần Béo (23x19)pixel
*/
const static unsigned char __attribute__ ((progmem)) dan_beo_23x19[] = {
0x00, 0x00, 0x80, 0x43, 0xB2, 0x0F, 0x86, 0x44, 0x5C, 0xA2, 0xA6, 0x5C, 0x50, 0xB0, 0x40, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x40, 0xE3, 0xF4, 0xFA, 0xF0, 0xF7, 0x28, 0x78,
0xD8, 0xA8, 0xA8, 0xA4, 0x90, 0x58, 0x3E, 0x0A, 0x11, 0x11, 0x11, 0x11, 0x0A, 0x04, 0x07, 0x07,
0x06, 0x06, 0x05, 0x07, 0x07, 0x04, 
};
/* mũi tên
 *  
 */
const static unsigned char __attribute__ ((progmem)) mui_ten_5x4[] = {

  0x01, 0x07,0x0F, 0x07,0x01,

};
// số trứng lớn nhất (khác 0)
#define egg_max 30
// mảng cho 2 đối tượng 1 gà(0) và egg_max  trứng(1,2...egg_max )
byte object[1+egg_max][5]={0};
// mảng cho 2 nhân vật Cả mẹo(0) và Dần béo(1)
byte object2[1+1][4]={0};
//object[i][0]: tồn tại hay không
//object[i][1]: tọa độ x
//object[i][2]: tọa độ y
//object[i][3]: hướng (1 phải, 2 trên , 3 trái, 4 dưới)
//object[i][4]: hoành độ X0 -đỉnh parabol của trứng i
//
byte chon_nv_A;
byte chon_nv_B;
//lựa chọn nhân vật, mặc định A được chọn trước
byte Xmin, Ymin,Xmax, Ymax;//biên
//cài đặt chân input
#define fight_b A5
#define select_b A4
#define right_b A3
#define up_b A2
#define left_b A1
#define down_b A0
// Chương trình chạy 1 lần
 int diem, diem_cao,diem_ban_dau;
byte timedelay;
void setup()   {  
  /*   
Serial.begin(9600);
*/
           
  lcd.ON(); 
  lcd.SET(23,0,0,0,4);
pinMode(left_b,INPUT_PULLUP);       
pinMode(down_b,INPUT_PULLUP);
pinMode(right_b,INPUT_PULLUP); 
pinMode(up_b,INPUT_PULLUP); 
pinMode(fight_b,INPUT_PULLUP); 
pinMode(select_b,INPUT_PULLUP);

  
Xmin=0;
Xmax=125;
Ymin=0;
Ymax=63;
chon_nv_A=1;
chon_nv_B=0;
diem_ban_dau=5;
diem=diem_ban_dau;
diem_cao=diem;
timedelay=0;// không delay
start_game();
}
//===================================
void start_game(){
for(byte x=Xmin+15;x<Xmax ; x+=20){
  
lcd.elip(x,Ymax-10 , 5, 10,BLACK);
   lcd.display();
   
}
for(byte x=(Xmin+15); x<Xmax; x+=20){
  for( byte a=5; a<=15; a++){ 
lcd.elip(x, Ymax-15+a, a, 15-a,BLACK);
   lcd.display();
  delay(50);
lcd.elip(x, Ymax-15+a, a, 15-a,WHITE);

   lcd.display(); 
   
  }
  for( int y=Ymax-20; y>=(-10); y-=4){ 
lcd.elip(x, y, 5, 14,BLACK);
   lcd.display();
  delay(10);
lcd.elip(x, y, 5, 14,WHITE);
   lcd.display();
  }
}
lcd.clear();
lcd.rect(8, 22, 118, 11, BLACK);
lcd.Asc_String( 10, 24,Asc("A R D U I N O . V N"),BLACK);
lcd.rect(58, 54, 70, 11, BLACK);
lcd.Asc_String( 60, 55,Asc("By Thai Son"),BLACK);
lcd.display();
lap_vo_han();

lcd.clear();
  
}




//===========================================================
////////////////DI CHUYỂN GÀ////////////////////
void di_chuyen_ga( ){
  byte x_cu, y_cu, huong_cu;
  byte x_moi;
  x_cu=object[0][1];
  y_cu=object[0][2];
  huong_cu=object[0][3];
  //lấy thông tin 
  
if(huong_cu==1){//gà quay về bên phải
  x_moi=x_cu+1;
  lcd.Plus_Bitmap(x_moi, y_cu, 16,16,ga_mai_16x16, 0,MIRROR,BLACK);
  // xoay bitmap (mirror)
  //
}

if(huong_cu==3){//gà quay về bên trái
  x_moi=x_cu-1;
  lcd.Plus_Bitmap(x_moi, y_cu, 16,16,ga_mai_16x16,0,NO_MIRROR,BLACK);
  // không xoay (non mirror)
}
//ghi lại thông tin
object[0][1]=x_moi;
lcd.display();
  
}//vẽ gà
void xoa_ga( byte x, byte y){
  lcd.fillrect(x,y, 18,18,DELETE
  );//
  lcd.display();
}//xóa gà
void ga_di_va_de_trung(){// gà đi và đẻ trứng
  //////////// XỬ LÍ GÀ////////////
  //b1: cấp giấy khai sinh
if(object[0][0]==0){
  // nếu không tồn tại gà thì phải tạo gà
  // cấp thuộc tính cho đối tượng gà
  object[0][1]=Xmin+5;//hoành độ ban đầu
  object[0][2]= Ymin; // tung độ ban đầu
  object[0][3]= 1;//hướng sang bên phải
  object[0][0]=1; //cấp quyền tồn tại
}
//b2: gà đi và quay đầu
//lấy thông tin;
if(object[0][1]<=Xmin){
  // nếu gà đến biên trái thì phải quay đầu về bên phải
  object[0][3]=1;
//ghi lại thông tin
}

if(object[0][1]>=Xmax){
  // nếu gà đến biên phải thì phải quay đầu về bên trái
  object[0][3]=3;
//ghi lại thông tin
}
  ///////////GÀ ĐANG ĐI/////////
  // lấy tt
  
  xoa_ga( object[0][1], object[0][2]);//xóa ảnh cũ
di_chuyen_ga();// vẽ ảnh mới

  
}
//===============================================================
////////////////////TRỨNG RƠI//////////////////////
void ve_trung(byte x, byte y){
  lcd.bitmap(x,y, 6,7, trung_6x7, BLACK);
  lcd.display();
}
void xoa_trung( byte x, byte y){
  //xóa = hình chữ nhật màu trắng
  lcd.fillrect(x,y,7,7,DELETE);
  lcd.display();
}
void di_chuyen_trung( byte huong_cu, byte i){
byte x_cu, y_cu,x_moi, y_moi, ton_tai, huong_moi;
//lây tt
x_cu=object[i][1];
y_cu=object[i][2];
ton_tai=object[i][0];
if((huong_cu==4)&&(ton_tai==1)){
  //trứng rơi xuống dưới;
  y_moi=y_cu+1;
  x_moi=x_cu;
  huong_moi=huong_cu;
  ve_trung(x_moi, y_moi);
  
}
//ghi tt
object[i][1]=x_moi;
object[i][2]=y_moi;
object[i][3]=huong_moi;
  
}
void ve_trung_roi(){
  for( byte i=1; i<=egg_max; i++){// xét lần lượt từng quả trứng 

    
  //vẽ trứng rơi
  if(object[i][0]==0){
    
  // nếu không tồn tại trứng thì phải tạo trứng
  //b1: chuẩn bị sẵn tọa độ  bằng random
  randomSeed( millis()%5000);
  byte X_random;
  X_random=random(Xmin, Xmax);
  // lưu thông tin
  object[i][1]=X_random;
  //chương trình chỉ chạy 1 lần mà thôi
  }
  //khi gà đi đến vị trí chuẩn bị sẵn này, trứng bắt đầu được tạo và rơi
  if(object[i][1]==object[0][1]){// thỏa mãn trùng tọa độ
  //b2: cấp giấy khai sinh
  // cấp thuộc tính cho đối tượng trứng
  //(nên nhớ đã có hoành độ Random) 
 object[i][2]= Ymin+10; // tung độ ban đầu 
 object[i][3]=4 ;//hướng xuống dưới
 object[i][0]=1; //cấp quyền tồn tại
         
  }
  
if((object[i][3]==3)||(object[i][3]==1)){
// nếu trứng i này đang bay theo parabol
//thì phải nhảy sang trứng khác
  continue;
}
//b2 : trứng roi
//lấy thông tin

xoa_trung(object[i][1],object[i][2]);//xóa ảnh cũ
di_chuyen_trung(object[i][3],i);// vẽ ảnh mới
//b3: Trứng chạm đất và vỡ
// hàm test nếu tung độ quá biên thì mất quả trứng đó
if( object[i][2]>=Ymax){
   object[i][0]=0;// xóa quyền tồn tại
   diem--;//trừ điểm
}
}//for
}
////================================================
////////ĐIỀU KHIỂN 2 NHÂN VẬT//////////////////////
void ve_nhan_vat(byte x, byte y,byte huong,byte i){
  switch (i){

case 0:
    // vẽ Cả Mẹo
    if(huong==1){
      //quay về bên phải
      lcd.Plus_Bitmap(x,y,22,18,ca_meo_22x18,  0,NO_MIRROR,BLACK);
    }
    if(huong==3){
      //quay về bên trái
      lcd.Plus_Bitmap(x,y,22,18,ca_meo_22x18,0,MIRROR,BLACK);
    }
    lcd.display();
break;
case 1:
  
    if(huong==1){
      //quay về bên phải
      lcd.Plus_Bitmap(x,y,23,19,dan_beo_23x19,0,NO_MIRROR,BLACK);
    }
    if(huong==3){
      //quay về bên trái
      lcd.Plus_Bitmap(x,y,23,19,dan_beo_23x19, 0,MIRROR,BLACK);
    }
  
    lcd.display();
    //vẽ Dần Béo
  break;
  default:
  break;
}//switch

}// ve nhân vật
void xoa_nhan_vat(byte x, byte y){
lcd.fillrect(x,y-7,24,19+7,DELETE);
lcd.display();
  
}// xóa nhân vật
void ve_mui_ten(byte x, byte y){
  // mũi tên sẽ chỉ vào nhân vật i
    lcd.bitmap(x,y,5,4,mui_ten_5x4, BLACK);
    lcd.display();
   
}// vẽ mũi tên
void xoa_mui_ten(byte i){
  lcd.fillrect(object2[i][1]-5,object2[i][2]-7,20,5 ,DELETE);
  lcd.display();
}//xóa mũi tên

void di_chuyen_nhan_vat(byte i){
byte x_cu, y_cu, huong_cu;
byte x_moi;
//lấy thông tin
x_cu=object2[i][1];
y_cu=object2[i][2];
huong_cu=object2[i][3];
if(huong_cu==1){
  //đi về bên phải
  x_moi=x_cu+4;
  ve_nhan_vat(x_moi, y_cu, huong_cu, i);
  ve_mui_ten(x_cu+5, y_cu-7);
  
}

if(huong_cu==3){
  //đi về bên trái
  
  if(x_cu>=Xmin+4*2){
    //chống quá biên
  x_moi=x_cu-4;
  } else{
    x_moi=x_cu;
  }
  ve_nhan_vat(x_moi, y_cu, huong_cu, i); 
  
  ve_mui_ten(x_cu+5, y_cu-7);
}
//lưu thông tin

 object2[i][1]=x_moi; 


}//di chuyển nhân vật
void xu_li_nhan_vat(){
//b0: điều khiển lựa chọn nhân vật
if(digitalRead(fight_b)==0){//fight được nhấn
   if ( chon_nv_A == chon_nv_B){// đề phòng A bằng B
  chon_nv_A=1;
    chon_nv_B=0;
   }
  if ( chon_nv_A!= chon_nv_B){//để dảm bảo A khác B
chon_nv_A=!chon_nv_A;
chon_nv_B=!chon_nv_B;
  //đổi 
  }
}//if
  //b1: chọn nhân vật
byte i;
if ( (chon_nv_A == 1)&&(chon_nv_B == 0)){
  i=0;// nhân vật Cả Mẹo

}
if ( (chon_nv_A == 0)&&(chon_nv_B == 1)){
  i=1;// nhân vật Dần Béo
}
if(digitalRead(fight_b)==0){//fight được nhấn
  
  xoa_mui_ten(!i);
  ve_mui_ten( object2[i][1]+5, object2[i][2]-7);
}

  //b2: cấp giấy khai sinh (chỉ dùng khi start game)
if(object2[i][0]==0){
  // nếu không tồn tại gà thì phải tạo gà
  // cấp thuộc tính cho đối tượng gà
  object2[i][1]=Xmin+50*i;//hoành độ ban đầu
  object2[i][2]= Ymax-19; // tung độ ban đầu
  object2[i][3]=1 ;//hướng về bên phải
  object2[i][0]=1; //cấp quyền tồn tại
}

 
//b4: vẽ 2 nhân vật

for (byte j=0; j<=1; j++){
  
ve_nhan_vat(object2[j][1],object2[j][2],object2[j][3],j);
}
//b5: điều khiển hướng nhân vật i
byte read_button;
read_button =lcd.Pullup_4(right_b, up_b, left_b, down_b);
if( read_button==1){// nút right
  //ghi lại tt hướng
   object2[i][3]=1;
   xoa_mui_ten(!i);
 

  xoa_nhan_vat(object2[i][1],object2[i][2]);//xóa ảnh cũ
  //lấy thông tin tọa độ để xóa
  
di_chuyen_nhan_vat(i);// vẽ ảnh mới

}

if( read_button==3){// nút left
   object2[i][3]=3;
  

   xoa_mui_ten(!i);
  xoa_nhan_vat(object2[i][1],object2[i][2]);//xóa ảnh cũ
  //lấy thông tin tọa độ để xóa
  
di_chuyen_nhan_vat(i);// vẽ ảnh mới

}

}//xử lí nhân vật
//==================================================
////////////NẢY TRỨNG VÀ ĐIỂM//////////////////////
void trung_parabol( byte i){
//trứng-i bay theo quỹ đạo parabol 

 float f_y_moi;
 byte X0;// tọa độ đỉnh parabol
 //lấy thông tin
 byte x_cu, y_cu, huong_cu;
 byte x_moi, y_moi;
 x_cu=object[i][1];
 y_cu=object[i][2];
  huong_cu=object[i][3];
  xoa_trung(x_cu,y_cu);//xoas anhr cux
 if(huong_cu==1){// bay sang phải
x_moi=x_cu+1;
 }

 if(huong_cu==3){// bay sang trái
x_moi=x_cu-1;
 }
 // lấy tọa độ đỉnh
 X0=object[i][4];
f_y_moi=1.0+sq((float(X0)-float(x_moi))/4.0);//phương trình 
y_moi=int(f_y_moi);//ép kiểu thực về nguyên
lcd.bitmap(x_moi,y_moi,6,7,trung_6x7,BLACK);// xoay ảnh 90 độ
lcd.display();//cho phép hiển thị
//ghi tt
object[i][1]=x_moi;
object[i][2]=y_moi;
}
boolean va_tram(byte i, byte j){
  // kiểm tra va trạm của quả trứng i với nhân vật j (j=0 Cả Mẹo; j=1 Dần Béo)
  //nếu cậu ta hướng sang trái thì hoành độ vợt là tọa độ  bitmap

  byte x_vot, y_vot;
  if(object2[j][3]==3){x_vot=object2[j][1]+5;}
  // nếu  sang phải thì hoành độ vợt + thêm 1 đoạn
  if(object2[j][3]==1){ x_vot=object2[j][1]+18;}
  y_vot=object2[j][2]+12;
  // nếu tọa độ vợt trù tọa độ trứng mà dương và trong 1 khoảng cố định
int hieu_x, hieu_y;
hieu_x=x_vot-object[i][1];
hieu_y=y_vot-object[i][2];
if((hieu_x>=0)&&(hieu_y>=0)&&(hieu_x<=8)&&(hieu_y<=8)){
  return 1;// trả về true
  
}else{
   return 0;// false 
   
}
  
}
void xu_li_nay_trung(){
//trứng sẽ bay về phía trước Cả Béo khi cậu ta đỡ trứng bằng vợt
//trứng được hứng bởi Cả Mẹo, cộng điểm nếu hứng được
//trừ điểm nếu để trứng vỡ

  for(byte i=1; i<=egg_max; i++){// xét lần lượt từng quả trứng

if(object[i][0]==0){
  continue;}else{
/////////QUẢ TRÚNG VÀ DẦN BÉO////////////////
  //b1: cài tọa độ ,hoành độ đỉnh và hướng bay
    if(va_tram(i,1)==1){// dần béo đã đỡ được trứng
      
     if( object2[1][3]==1){// và đang hướng sang bên phải
     
      //trúng bay sang  phải
      object[i][4]=object[i][1]+25;
       object[i][3]=1;
      
     }
     if( object2[1][3]==3){// và đang hướng sang bên trái
       //trúng bay sang trái
     
      object[i][3]=3;
      object[i][4]=object[i][1]-25;
      
     }
    
     diem+=2;//cộng 2 điểm
    }
 //b2: vẽ 
    if((object[i][3]==1)||(object[i][3]==3)){// trứng đang bay

trung_parabol(i);
    }
//////////QUẢ TRỨNG VÀ CẢ MẸO/////////////////
 if(va_tram(i,0)==1){// CẢ MẸO đã đỡ được trứng
 object[i][0]=0;// xóa quyền tồn tại quả i
   diem++;//cộng 1 điểm
  
 }
//đỡ hụt
if( object[i][2]>=Ymax-5){
   object[i][0]=0;// xóa quyền tồn tại quả i
   xoa_trung(object[i][1],object[i][2]);
   if( (object[i][3]==1)||(object[i][3]==3)){
    //rơi parabol
    
   diem-=2;//trừ 2 điểm
   }
   if(object[i][3]==4){
    //rơi thường
     diem-=1;//trừ 1 điểm
   }
}
}//if
  }//for

if (diem>=diem_cao){
  diem_cao=diem;
}
   
}
//=============================================

void in_diem(){
  lcd.fillrect(Xmin+1,Ymin , 25,20,DELETE);  
  lcd.Number_Long(Xmin+2,Ymin,diem,ASCII_NUMBER,BLACK);
  lcd.drawline(Xmin+2,Ymin+8,Xmin+20,Ymin+8,BLACK);
  lcd.Number_Long(Xmin+2,Ymin+10,diem_cao,ASCII_NUMBER,BLACK);
  
  lcd.display();
}
//===========================================================


void lap_vo_han(){
// dừng dòng chảy chính bằng vòng lặp vô hạn
//thoát lặp khi nút Fight được nhấn

int y=55;
lcd.Asc_String(10,y+2 ,Asc("Fight!"), BLACK);
 lcd.display();
  while(digitalRead(fight_b)!=0){
lcd.rect(8,55,40, 10, BLACK);
  lcd.display();
  if(digitalRead(fight_b)==0){
    
    break;// thoát ngay
  }
  delay(250);

lcd.rect(8,y,40, 10, DELETE);
 lcd.display();
 
  if(digitalRead(fight_b)==0){
    break;// thoát ngay
  }
  delay(250);
  }
}//đóng lặp vô hạn
//=========================
void reset(){
  
  for(byte i=0; i<=egg_max;i++){
    for(byte j=0; j<=4;j++){
    object[i][j]=0;
     }
     }
   for(byte i=0; i<=1;i++){
    for(byte j=0; j<=3;j++){
    object2[i][j]=0;
     }
     }
  
}
//======================
void game_over( int diem_choi){
  if(diem_choi<=0){
  reset();
  lcd.clear();
  diem=diem_ban_dau;
  lap_vo_han();
  lcd.clear();
  }
}
//=======================
void loop() {
  
ga_di_va_de_trung();
ve_trung_roi();
xu_li_nhan_vat();
xu_li_nay_trung();
in_diem();
game_over(diem);
  delay(timedelay);

  /* test trứng + gà
  for(byte i=0; i<=egg_max;i++){
    
  for(byte j=0; j<=4;j++){
    
  Serial.print("________");
  
  Serial.print(object[i][j]);
    
  }
  Serial.println("");
  }
  
  Serial.println("===============");
  */
}
