
#include "ST7565_homephone.h"
// add a bitmap library of a 16x16 fruit icon
#include "bmps.h"

ST7565 lcd(3,4,5,6);
 
const static unsigned char __attribute__ ((progmem)) ga_mai_16x16[]= {
0x20, 0xD8, 0x2C, 0x0C, 0x9E, 0x72, 0x42, 0xC0, 0x40, 0x40, 0x60, 0xFC, 0xCE, 0x3B, 0x7B, 0x01,
0x00, 0x06, 0x09, 0x10, 0x30, 0x48, 0x44, 0x4E, 0x59, 0x71, 0x39, 0x1F, 0x0E, 0x00, 0x00, 0x00
};
/* Qủa trứng (6x7) pixel
 *  */
 
const static unsigned char __attribute__ ((progmem)) trung_6x7 [] = {
0x1C, 0x22, 0x41, 0x41, 0x22, 0x1C, 
};

/** Nhân vật Cả Mẹo (22x18)pixel
*/
const static unsigned char __attribute__ ((progmem)) ca_meo_22x18[] = {
0x60, 0x9C, 0x62, 0x01, 0x01, 0xC1, 0x26, 0x29, 0x29, 0x4B, 0x4E, 0x48, 0x70, 0x00, 0xC0, 0x80,
0x80, 0x80, 0x80, 0x80, 0x80, 0xC0, 0x00, 0x00, 0x01, 0x01, 0x02, 0xE4, 0xFF, 0xFE, 0xFE, 0xFE,
0xFC, 0x1C, 0x0E, 0x06, 0x1F, 0x21, 0x52, 0x44, 0x48, 0x52, 0x21, 0x1F, 0x00, 0x00, 0x64, 0x70,
0x2F, 

};
/** Nhân vật Dần Béo (23x19)pixel
*/
const static unsigned char __attribute__ ((progmem)) dan_beo_23x19[] = {
0x00, 0x00, 0x80, 0x43, 0xB2, 0x0F, 0x86, 0x44, 0x5C, 0xA2, 0xA6, 0x5C, 0x50, 0xB0, 0x40, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x40, 0xE3, 0xF4, 0xFA, 0xF0, 0xF7, 0x28, 0x78,
0xD8, 0xA8, 0xA8, 0xA4, 0x90, 0x58, 0x3E, 0x0A, 0x11, 0x11, 0x11, 0x11, 0x0A, 0x04, 0x07, 0x07,
0x06, 0x06, 0x05, 0x07, 0x07, 0x04, 
};
byte Xmin, Ymin,Xmax, Ymax;//biên
// mảng cho 2 đối tượng 1 gà(0) và 3 trứng(1,2.3)
byte object[1+3][4];
// mảng cho 2 nhân vật Cả mẹo và Dần béo
byte object2[1+1][4];
//object[i][0]: tồn tại hay không
//object[i][1]: tọa độ x
//object[i][2]: tọa độ y
//object[i][3]: hướng (1 phải, 2 trên , 3 trái, 4 dưới)
//
// Chương trình chạy 1 lần
void setup()   {             
  lcd.ON(); 
  lcd.SET(23,0,0,0,4);
  
Xmin=0;
Xmax=125;
Ymin=0;
Ymax=63;

}
//===========================================================
////////////////DI CHUYỂN GÀ////////////////////
void di_chuyen_ga( ){
  byte x_cu, y_cu, huong_cu;
  byte x_moi;
  x_cu=object[0][1];
  y_cu=object[0][2];
  huong_cu=object[0][3];
  //lấy thông tin 
  
if(huong_cu==1){//gà quay về bên phải
  x_moi=x_cu+1;
  lcd.Plus_Bitmap(x_moi, y_cu, 16,16,ga_mai_16x16, 0,MIRROR,BLACK);
  // xoay bitmap (mirror)
  //
}

if(huong_cu==3){//gà quay về bên trái
  x_moi=x_cu-1;
  lcd.Plus_Bitmap(x_moi, y_cu, 16,16,ga_mai_16x16,0,NO_MIRROR,BLACK);
  // không xoay (non mirror)
}
//ghi lại thông tin
object[0][1]=x_moi;
lcd.display();
  
}//vẽ gà
void xoa_ga( byte x, byte y){
  lcd.fillrect(x,y, 18,18,DELETE
  );//
  lcd.display();
}//xóa gà
void ga_di_va_de_trung(){// gà đi và đẻ trứng
  //////////// XỬ LÍ GÀ////////////
  //b1: cấp giấy khai sinh
if(object[0][0]==0){
  // nếu không tồn tại gà thì phải tạo gà
  // cấp thuộc tính cho đối tượng gà
  object[0][1]=Xmin+5;//hoành độ ban đầu
  object[0][2]= Ymin; // tung độ ban đầu
  object[0][3]= 1;//hướng sang bên phải
  object[0][0]=1; //cấp quyền tồn tại
}
//b2: gà đi và quay đầu
//lấy thông tin;
if(object[0][1]<=Xmin){
  // nếu gà đến biên trái thì phải quay đầu về bên phải
  object[0][3]=1;
//ghi lại thông tin
}

if(object[0][1]>=Xmax){
  // nếu gà đến biên phải thì phải quay đầu về bên trái
  object[0][3]=3;
//ghi lại thông tin
}
  ///////////GÀ ĐANG ĐI/////////
  // lấy tt
  
  xoa_ga( object[0][1], object[0][2]);//xóa ảnh cũ
di_chuyen_ga();// vẽ ảnh mới

  
}
//===============================================================
////////////////////TRỨNG RƠI//////////////////////
void ve_trung(byte x, byte y){
  lcd.bitmap(x,y, 6,7, trung_6x7, BLACK);
  lcd.display();
}
void xoa_trung( byte x, byte y){
  //xóa = hình chữ nhật màu trắng
  lcd.fillrect(x,y,7,7,DELETE);
  lcd.display();
}
void di_chuyen_trung( byte huong_cu, byte i){
byte x_cu, y_cu,x_moi, y_moi, ton_tai, huong_moi;
//lây tt
x_cu=object[i][1];
y_cu=object[i][2];
ton_tai=object[i][0];
if((huong_cu==4)&&(ton_tai==1)){
  //trứng rơi xuống dưới;
  y_moi=y_cu+1;
  x_moi=x_cu;
  huong_moi=huong_cu;
  ve_trung(x_moi, y_moi);
  
}
//ghi tt
object[i][1]=x_moi;
object[i][2]=y_moi;
object[i][3]=huong_moi;
  
}
void ve_trung_roi(){
  for( byte i=1; i<=egg_max; i++){// xét lần lượt từng quả trứng 

    
  //vẽ trứng rơi
  if(object[i][0]==0){
    
  // nếu không tồn tại trứng thì phải tạo trứng
  //b1: chuẩn bị sẵn tọa độ  bằng random
  randomSeed( millis()%5000);
  byte X_random;
  X_random=random(Xmin, Xmax);
  // lưu thông tin
  object[i][1]=X_random;
  //chương trình chỉ chạy 1 lần mà thôi
  }
  //khi gà đi đến vị trí chuẩn bị sẵn này, trứng bắt đầu được tạo và rơi
  if(object[i][1]==object[0][1]){// thỏa mãn trùng tọa độ
  //b2: cấp giấy khai sinh
  // cấp thuộc tính cho đối tượng trứng
  //(nên nhớ đã có hoành độ Random) 
 object[i][2]= Ymin+10; // tung độ ban đầu 
 object[i][3]=4 ;//hướng xuống dưới
 object[i][0]=1; //cấp quyền tồn tại
         
  }
  
if((object[i][3]==3)||(object[i][3]==1)){
// nếu trứng i này đang bay theo parabol
//thì phải nhảy sang trứng khác
  continue;
}
//b2 : trứng roi
//lấy thông tin

xoa_trung(object[i][1],object[i][2]);//xóa ảnh cũ
di_chuyen_trung(object[i][3],i);// vẽ ảnh mới
//b3: Trứng chạm đất và vỡ
// hàm test nếu tung độ quá biên thì mất quả trứng đó
if( object[i][2]>=Ymax){
   object[i][0]=0;// xóa quyền tồn tại
   diem--;//trừ điểm
}
}//for
}
////================================================
/////////////////NẢY TRỨNG//////////////////////////////
////////thêm tiếp 2 đối tượng mới 
void loop() {


ga_di_va_de_trung();
ve_trung_roi();
  delay(100);
}
